﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WpfTestingSample.Model;

namespace WpfTestingSample
{
    class ViewModel:INotifyPropertyChanged
    {
        EmployeeDetails emp = new EmployeeDetails();
       
        #region Constructor

        public ViewModel()
        {
            this.GDCSource = emp;
            companies = new ObservableCollection<CompanyItem>()
                {
                new CompanyItem() { CountryCode = "NR", CountryName = "NAURU" },
                new CompanyItem() { CountryCode = "NP", CountryName = "NEPAL" },
                new CompanyItem() { CountryCode = "NL", CountryName = "NETHERLANDS" },
                new CompanyItem() { CountryCode = "NZ", CountryName = "NEW ZEALAND" },
                new CompanyItem() { CountryCode = "NI", CountryName = "NICARAGUA" },
                new CompanyItem() { CountryCode = "NE", CountryName = "NIGER" },
                new CompanyItem() { CountryCode = "NG", CountryName = "NIGERIA" },
                new CompanyItem() { CountryCode = "NU", CountryName = "NIUE" }  
                };
        }

        #endregion

        private ObservableCollection<BusinessObjects> gdcsource;
        public ObservableCollection<BusinessObjects> GDCSource
        {
            get
            {
                return gdcsource;
            }
            set
            {
                gdcsource = value;
                OnPropertyChanged("GDCSource");
            }
        }

        private ObservableCollection<CompanyItem> companies;
        public ObservableCollection<CompanyItem> Companies
        {
            get { return companies; }
            set { companies = value; }
        }

        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

    }

    class EmployeeDetails : ObservableCollection<BusinessObjects>
    {
        Random rand = new Random();
        public EmployeeDetails()
        {
            PopulateCollection();
        }

        private void PopulateCollection()
        {
            this.Clear();

            BusinessObjects b = new BusinessObjects() { EmployeeName = "Mart", CountryCode = "NR",  EmployeeAge = 1, EmployeeArea = "101010", EmployeeSalary = 1.7, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Peter", CountryCode = "NP", EmployeeAge = 1, EmployeeArea = "010101", EmployeeSalary = 2.5, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "James", CountryCode = "NL", EmployeeAge = 42, EmployeeArea = "1222111", EmployeeSalary = 18700, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Oliver", CountryCode = "NZ", EmployeeAge = 36, EmployeeArea = "011111", EmployeeSalary = 67000, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Robert", CountryCode = "NI", EmployeeAge = 54, EmployeeArea = "111111", EmployeeSalary = 34567, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Suji", CountryCode = "NE", EmployeeAge = 45, EmployeeArea = "11111111", EmployeeSalary = 90000, ExperienceInMonth = 10, EmployeeGender = "Female", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Mahesh", CountryCode = "NG", EmployeeAge = 48, EmployeeArea = "111111111", EmployeeSalary = 34567, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
        }
    }

    class CompanyItem:INotifyPropertyChanged
    {
        private string _countryCode;
        public string CountryCode
        {
            get
            {
                return _countryCode;
            }
            set
            {
                _countryCode = value;
                OnPropertyChanged("CountryCode");
            }
        }

        private string _countryName;
        public string CountryName
        {
            get
            {
                return _countryName;
            }
            set
            {
                _countryName = value;
                OnPropertyChanged("CountryName");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }

}
